"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var z = __importStar(require("./types/base"));
var _1 = require(".");
var util_1 = require("./helpers/util");
// import { ZodArray } from './types/array';
// import { ZodObject } from './types/object';
// import { ZodUnion } from './types/union';
// import { ZodIntersection } from './types/intersection';
// import { ZodTuple } from './types/tuple';
// import { ZodRecord } from './types/record';
// import { ZodLazy } from './types/lazy';
var ZodError_1 = require("./ZodError");
exports.ParamVisitor = function (visit) { return function (schema, params) {
    var def = schema._def;
    switch (def.t) {
        case z.ZodTypes.string:
            return visit(schema, params);
        case z.ZodTypes.number:
            return visit(schema, params);
        case z.ZodTypes.boolean:
            return visit(schema, params);
        case z.ZodTypes.date:
            return visit(schema, params);
        case z.ZodTypes.undefined:
            return visit(schema, params);
        case z.ZodTypes.null:
            return visit(schema, params);
        case z.ZodTypes.array:
            return visit(new _1.ZodArray(__assign({}, def, { type: visit(def.type, params) })), params);
        case z.ZodTypes.object:
            var visitedShape = {};
            for (var key in def.shape) {
                visitedShape[key] = visit(def.shape[key], params[key]);
            }
            return visit(new _1.ZodObject(__assign({}, def, { shape: visitedShape })), params);
        case z.ZodTypes.union:
            return visit(new _1.ZodUnion(__assign({}, def, { options: def.options.map(function (option) { return visit(option, params); }) })), params);
        case z.ZodTypes.intersection:
            return visit(new _1.ZodIntersection(__assign({}, def, { left: visit(def.left, params), right: visit(def.left, params) })), params);
        case z.ZodTypes.tuple:
            return visit(new _1.ZodTuple(__assign({}, def, { items: def.items.map(function (item) { return visit(item, params); }) })), params);
        case z.ZodTypes.record:
            return visit(new _1.ZodRecord(__assign({}, def, { valueType: visit(def.valueType, params) })), params);
        case z.ZodTypes.lazy:
            return visit(new _1.ZodLazy(__assign({}, def, { getter: function () { return visit(def.getter(), params); } })), params);
        case z.ZodTypes.literal:
            return visit(schema, params);
        case z.ZodTypes.enum:
            return visit(schema, params);
        default:
            util_1.util.assertNever(def);
            break;
    }
    throw ZodError_1.ZodError.fromString("Unknown schema type.");
}; };
//# sourceMappingURL=sampleParamVisitor.js.map