import { ParseParams } from '../parser';
import { maskUtil } from '../helpers/maskUtil';
export declare enum ZodTypes {
    string = "string",
    number = "number",
    boolean = "boolean",
    date = "date",
    undefined = "undefined",
    null = "null",
    array = "array",
    object = "object",
    union = "union",
    intersection = "intersection",
    tuple = "tuple",
    record = "record",
    function = "function",
    lazy = "lazy",
    lazyobject = "lazyobject",
    literal = "literal",
    enum = "enum"
}
export declare type ZodAny = ZodType<any>;
export declare type ZodRawShape = {
    [k: string]: ZodAny;
};
export interface ZodTypeDef {
    t: ZodTypes;
}
export declare type TypeOf<T extends {
    _type: any;
}> = T['_type'];
export declare type Infer<T extends {
    _type: any;
}> = T['_type'];
export declare abstract class ZodType<Type, Def extends ZodTypeDef = ZodTypeDef> {
    readonly _type: Type;
    readonly _def: Def;
    parse: (x: Type, params?: ParseParams) => Type;
    is(u: Type): u is Type;
    check(u: Type): u is Type;
    mask: <P extends {
        array: Type extends (infer U)[] ? true | { [k in keyof U]?: true | {
            array: U[k] extends (infer U)[] ? true | any : never;
            object: U[k] extends {
                [k: string]: any;
            } ? { [k in keyof U[k]]?: true | {
                array: U[k][k] extends (infer U)[] ? true | any : never;
                object: U[k][k] extends {
                    [k: string]: any;
                } ? { [k in keyof U[k][k]]?: true | {
                    array: U[k][k][k] extends (infer U)[] ? true | any : never;
                    object: U[k][k][k] extends {
                        [k: string]: any;
                    } ? { [k in keyof U[k][k][k]]?: true | {
                        array: U[k][k][k][k] extends (infer U)[] ? true | any : never;
                        object: U[k][k][k][k] extends {
                            [k: string]: any;
                        } ? { [k in keyof U[k][k][k][k]]?: true | {
                            array: U[k][k][k][k][k] extends (infer U)[] ? true | any : never;
                            object: U[k][k][k][k][k] extends {
                                [k: string]: any;
                            } ? { [k in keyof U[k][k][k][k][k]]?: true | {
                                array: U[k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                object: U[k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                } ? { [k in keyof U[k][k][k][k][k][k]]?: true | {
                                    array: U[k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                    object: U[k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof U[k][k][k][k][k][k][k]]?: true | {
                                        array: U[k][k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                        object: U[k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k][k][k][k][k][k][k][k]]?: true | {
                                            array: U[k][k][k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k][k][k][k][k][k][k][k]]?: true | {
                                                array: U[k][k][k][k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k][k][k][k][k][k][k][k]]?: true | any[U[k][k][k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k][k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? U[k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[U[k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (U[k][k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                } ? U[k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                rest: never;
                                never: never;
                            }[U[k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k] extends {
                                [k: string]: any;
                            }[] ? "array" : (U[k][k][k][k][k][k] extends {
                                [k: string]: any;
                            } ? U[k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                            rest: never;
                            never: never;
                        }[U[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k] ? "never" : U[k][k][k][k][k] extends {
                            [k: string]: any;
                        }[] ? "array" : (U[k][k][k][k][k] extends {
                            [k: string]: any;
                        } ? U[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                        rest: never;
                        never: never;
                    }[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                        [k: string]: any;
                    }[] ? "array" : (U[k][k][k][k] extends {
                        [k: string]: any;
                    } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                    rest: never;
                    never: never;
                }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                    [k: string]: any;
                }[] ? "array" : (U[k][k][k] extends {
                    [k: string]: any;
                } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                rest: never;
                never: never;
            }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                [k: string]: any;
            }[] ? "array" : (U[k][k] extends {
                [k: string]: any;
            } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
            rest: never;
            never: never;
        }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
            [k: string]: any;
        }[] ? "array" : (U[k] extends {
            [k: string]: any;
        } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
        object: Type extends {
            [k: string]: any;
        } ? { [k in keyof Type]?: true | {
            array: Type[k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                array: U[k] extends (infer U)[] ? true | any : never;
                object: U[k] extends {
                    [k: string]: any;
                } ? { [k in keyof U[k]]?: true | {
                    array: U[k][k] extends (infer U)[] ? true | any : never;
                    object: U[k][k] extends {
                        [k: string]: any;
                    } ? { [k in keyof U[k][k]]?: true | {
                        array: U[k][k][k] extends (infer U)[] ? true | any : never;
                        object: U[k][k][k] extends {
                            [k: string]: any;
                        } ? { [k in keyof U[k][k][k]]?: true | {
                            array: U[k][k][k][k] extends (infer U)[] ? true | any : never;
                            object: U[k][k][k][k] extends {
                                [k: string]: any;
                            } ? { [k in keyof U[k][k][k][k]]?: true | {
                                array: U[k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                object: U[k][k][k][k][k] extends {
                                    [k: string]: any;
                                } ? { [k in keyof U[k][k][k][k][k]]?: true | {
                                    array: U[k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                    object: U[k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof U[k][k][k][k][k][k]]?: true | {
                                        array: U[k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                        object: U[k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k][k][k][k][k][k][k]]?: true | {
                                            array: U[k][k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k][k][k][k][k][k][k]]?: true | {
                                                array: U[k][k][k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k][k][k][k][k][k][k]]?: true | any[U[k][k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? U[k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[U[k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (U[k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                } ? U[k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                rest: never;
                                never: never;
                            }[U[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k] ? "never" : U[k][k][k][k][k] extends {
                                [k: string]: any;
                            }[] ? "array" : (U[k][k][k][k][k] extends {
                                [k: string]: any;
                            } ? U[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                            rest: never;
                            never: never;
                        }[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                            [k: string]: any;
                        }[] ? "array" : (U[k][k][k][k] extends {
                            [k: string]: any;
                        } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                        rest: never;
                        never: never;
                    }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                        [k: string]: any;
                    }[] ? "array" : (U[k][k][k] extends {
                        [k: string]: any;
                    } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                    rest: never;
                    never: never;
                }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                    [k: string]: any;
                }[] ? "array" : (U[k][k] extends {
                    [k: string]: any;
                } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                rest: never;
                never: never;
            }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                [k: string]: any;
            }[] ? "array" : (U[k] extends {
                [k: string]: any;
            } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
            object: Type[k] extends {
                [k: string]: any;
            } ? { [k in keyof Type[k]]?: true | {
                array: Type[k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                    array: U[k] extends (infer U)[] ? true | any : never;
                    object: U[k] extends {
                        [k: string]: any;
                    } ? { [k in keyof U[k]]?: true | {
                        array: U[k][k] extends (infer U)[] ? true | any : never;
                        object: U[k][k] extends {
                            [k: string]: any;
                        } ? { [k in keyof U[k][k]]?: true | {
                            array: U[k][k][k] extends (infer U)[] ? true | any : never;
                            object: U[k][k][k] extends {
                                [k: string]: any;
                            } ? { [k in keyof U[k][k][k]]?: true | {
                                array: U[k][k][k][k] extends (infer U)[] ? true | any : never;
                                object: U[k][k][k][k] extends {
                                    [k: string]: any;
                                } ? { [k in keyof U[k][k][k][k]]?: true | {
                                    array: U[k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                    object: U[k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof U[k][k][k][k][k]]?: true | {
                                        array: U[k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                        object: U[k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k][k][k][k][k][k]]?: true | {
                                            array: U[k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k][k][k][k][k][k]]?: true | {
                                                array: U[k][k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k][k][k][k][k][k]]?: true | any[U[k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? U[k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[U[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k] ? "never" : U[k][k][k][k][k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (U[k][k][k][k][k] extends {
                                    [k: string]: any;
                                } ? U[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                rest: never;
                                never: never;
                            }[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                                [k: string]: any;
                            }[] ? "array" : (U[k][k][k][k] extends {
                                [k: string]: any;
                            } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                            rest: never;
                            never: never;
                        }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                            [k: string]: any;
                        }[] ? "array" : (U[k][k][k] extends {
                            [k: string]: any;
                        } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                        rest: never;
                        never: never;
                    }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                        [k: string]: any;
                    }[] ? "array" : (U[k][k] extends {
                        [k: string]: any;
                    } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                    rest: never;
                    never: never;
                }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                    [k: string]: any;
                }[] ? "array" : (U[k] extends {
                    [k: string]: any;
                } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                object: Type[k][k] extends {
                    [k: string]: any;
                } ? { [k in keyof Type[k][k]]?: true | {
                    array: Type[k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                        array: U[k] extends (infer U)[] ? true | any : never;
                        object: U[k] extends {
                            [k: string]: any;
                        } ? { [k in keyof U[k]]?: true | {
                            array: U[k][k] extends (infer U)[] ? true | any : never;
                            object: U[k][k] extends {
                                [k: string]: any;
                            } ? { [k in keyof U[k][k]]?: true | {
                                array: U[k][k][k] extends (infer U)[] ? true | any : never;
                                object: U[k][k][k] extends {
                                    [k: string]: any;
                                } ? { [k in keyof U[k][k][k]]?: true | {
                                    array: U[k][k][k][k] extends (infer U)[] ? true | any : never;
                                    object: U[k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof U[k][k][k][k]]?: true | {
                                        array: U[k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                        object: U[k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k][k][k][k][k]]?: true | {
                                            array: U[k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k][k][k][k][k]]?: true | {
                                                array: U[k][k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k][k][k][k][k]]?: true | any[U[k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k] ? "never" : U[k][k][k][k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? U[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (U[k][k][k][k] extends {
                                    [k: string]: any;
                                } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                rest: never;
                                never: never;
                            }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                                [k: string]: any;
                            }[] ? "array" : (U[k][k][k] extends {
                                [k: string]: any;
                            } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                            rest: never;
                            never: never;
                        }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                            [k: string]: any;
                        }[] ? "array" : (U[k][k] extends {
                            [k: string]: any;
                        } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                        rest: never;
                        never: never;
                    }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                        [k: string]: any;
                    }[] ? "array" : (U[k] extends {
                        [k: string]: any;
                    } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                    object: Type[k][k][k] extends {
                        [k: string]: any;
                    } ? { [k in keyof Type[k][k][k]]?: true | {
                        array: Type[k][k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                            array: U[k] extends (infer U)[] ? true | any : never;
                            object: U[k] extends {
                                [k: string]: any;
                            } ? { [k in keyof U[k]]?: true | {
                                array: U[k][k] extends (infer U)[] ? true | any : never;
                                object: U[k][k] extends {
                                    [k: string]: any;
                                } ? { [k in keyof U[k][k]]?: true | {
                                    array: U[k][k][k] extends (infer U)[] ? true | any : never;
                                    object: U[k][k][k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof U[k][k][k]]?: true | {
                                        array: U[k][k][k][k] extends (infer U)[] ? true | any : never;
                                        object: U[k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k][k][k][k]]?: true | {
                                            array: U[k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k][k][k][k]]?: true | {
                                                array: U[k][k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k][k][k][k]]?: true | any[U[k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k] ? "never" : U[k][k][k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (U[k][k][k] extends {
                                    [k: string]: any;
                                } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                rest: never;
                                never: never;
                            }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                                [k: string]: any;
                            }[] ? "array" : (U[k][k] extends {
                                [k: string]: any;
                            } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                            rest: never;
                            never: never;
                        }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                            [k: string]: any;
                        }[] ? "array" : (U[k] extends {
                            [k: string]: any;
                        } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                        object: Type[k][k][k][k] extends {
                            [k: string]: any;
                        } ? { [k in keyof Type[k][k][k][k]]?: true | {
                            array: Type[k][k][k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                                array: U[k] extends (infer U)[] ? true | any : never;
                                object: U[k] extends {
                                    [k: string]: any;
                                } ? { [k in keyof U[k]]?: true | {
                                    array: U[k][k] extends (infer U)[] ? true | any : never;
                                    object: U[k][k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof U[k][k]]?: true | {
                                        array: U[k][k][k] extends (infer U)[] ? true | any : never;
                                        object: U[k][k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k][k][k]]?: true | {
                                            array: U[k][k][k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k][k][k]]?: true | {
                                                array: U[k][k][k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k][k][k]]?: true | any[U[k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k][k] ? "never" : U[k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k] ? "never" : U[k][k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k][k][k] extends {
                                        [k: string]: any;
                                    } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (U[k][k] extends {
                                    [k: string]: any;
                                } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                rest: never;
                                never: never;
                            }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                                [k: string]: any;
                            }[] ? "array" : (U[k] extends {
                                [k: string]: any;
                            } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                            object: Type[k][k][k][k][k] extends {
                                [k: string]: any;
                            } ? { [k in keyof Type[k][k][k][k][k]]?: true | {
                                array: Type[k][k][k][k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                                    array: U[k] extends (infer U)[] ? true | any : never;
                                    object: U[k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof U[k]]?: true | {
                                        array: U[k][k] extends (infer U)[] ? true | any : never;
                                        object: U[k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k][k]]?: true | {
                                            array: U[k][k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k][k]]?: true | {
                                                array: U[k][k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k][k]]?: true | any[U[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k][k] ? "never" : U[k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k][k] extends {
                                        [k: string]: any;
                                    } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (U[k] extends {
                                    [k: string]: any;
                                } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                object: Type[k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                } ? { [k in keyof Type[k][k][k][k][k][k]]?: true | {
                                    array: Type[k][k][k][k][k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                                        array: U[k] extends (infer U)[] ? true | any : never;
                                        object: U[k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof U[k]]?: true | {
                                            array: U[k][k] extends (infer U)[] ? true | any : never;
                                            object: U[k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k][k]]?: true | {
                                                array: U[k][k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k][k]]?: true | any[U[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k][k] ? "never" : U[k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k][k] extends {
                                            [k: string]: any;
                                        } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (U[k] extends {
                                        [k: string]: any;
                                    } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    object: Type[k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? { [k in keyof Type[k][k][k][k][k][k][k]]?: true | {
                                        array: Type[k][k][k][k][k][k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                                            array: U[k] extends (infer U)[] ? true | any : never;
                                            object: U[k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof U[k]]?: true | {
                                                array: U[k][k] extends (infer U)[] ? true | any : never;
                                                object: U[k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k][k]]?: true | any[U[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k][k] ? "never" : U[k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k][k] extends {
                                                [k: string]: any;
                                            } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (U[k] extends {
                                            [k: string]: any;
                                        } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        object: Type[k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? { [k in keyof Type[k][k][k][k][k][k][k][k]]?: true | {
                                            array: Type[k][k][k][k][k][k][k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | {
                                                array: U[k] extends (infer U)[] ? true | any : never;
                                                object: U[k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof U[k]]?: true | any[U[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k][k] ? "never" : U[k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k][k] extends {
                                                    [k: string]: any;
                                                } ? U[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (U[k] extends {
                                                [k: string]: any;
                                            } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            object: Type[k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? { [k in keyof Type[k][k][k][k][k][k][k][k][k]]?: true | {
                                                array: Type[k][k][k][k][k][k][k][k][k][k] extends (infer U)[] ? true | { [k in keyof U]?: true | any[U[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends U[k] ? "never" : U[k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (U[k] extends {
                                                    [k: string]: any;
                                                } ? U[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                object: Type[k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? { [k in keyof Type[k][k][k][k][k][k][k][k][k][k]]?: true | any[Type[k][k][k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k][k][k][k][k][k][k][k] ? "never" : Type[k][k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                }[] ? "array" : (Type[k][k][k][k][k][k][k][k][k][k][k] extends {
                                                    [k: string]: any;
                                                } ? Type[k][k][k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                                rest: never;
                                                never: never;
                                            }[Type[k][k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k][k][k][k][k][k][k] ? "never" : Type[k][k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            }[] ? "array" : (Type[k][k][k][k][k][k][k][k][k][k] extends {
                                                [k: string]: any;
                                            } ? Type[k][k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                            rest: never;
                                            never: never;
                                        }[Type[k][k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k][k][k][k][k][k] ? "never" : Type[k][k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        }[] ? "array" : (Type[k][k][k][k][k][k][k][k][k] extends {
                                            [k: string]: any;
                                        } ? Type[k][k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                        rest: never;
                                        never: never;
                                    }[Type[k][k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k][k][k][k][k] ? "never" : Type[k][k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    }[] ? "array" : (Type[k][k][k][k][k][k][k][k] extends {
                                        [k: string]: any;
                                    } ? Type[k][k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                    rest: never;
                                    never: never;
                                }[Type[k][k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k][k][k][k] ? "never" : Type[k][k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                }[] ? "array" : (Type[k][k][k][k][k][k][k] extends {
                                    [k: string]: any;
                                } ? Type[k][k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                                rest: never;
                                never: never;
                            }[Type[k][k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k][k][k] ? "never" : Type[k][k][k][k][k][k] extends {
                                [k: string]: any;
                            }[] ? "array" : (Type[k][k][k][k][k][k] extends {
                                [k: string]: any;
                            } ? Type[k][k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                            rest: never;
                            never: never;
                        }[Type[k][k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k][k] ? "never" : Type[k][k][k][k][k] extends {
                            [k: string]: any;
                        }[] ? "array" : (Type[k][k][k][k][k] extends {
                            [k: string]: any;
                        } ? Type[k][k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                        rest: never;
                        never: never;
                    }[Type[k][k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k][k] ? "never" : Type[k][k][k][k] extends {
                        [k: string]: any;
                    }[] ? "array" : (Type[k][k][k][k] extends {
                        [k: string]: any;
                    } ? Type[k][k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                    rest: never;
                    never: never;
                }[Type[k][k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k][k] ? "never" : Type[k][k][k] extends {
                    [k: string]: any;
                }[] ? "array" : (Type[k][k][k] extends {
                    [k: string]: any;
                } ? Type[k][k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
                rest: never;
                never: never;
            }[Type[k][k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k][k] ? "never" : Type[k][k] extends {
                [k: string]: any;
            }[] ? "array" : (Type[k][k] extends {
                [k: string]: any;
            } ? Type[k][k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
            rest: never;
            never: never;
        }[Type[k] extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type[k] ? "never" : Type[k] extends {
            [k: string]: any;
        }[] ? "array" : (Type[k] extends {
            [k: string]: any;
        } ? Type[k] extends any[] ? false : true : false) extends true ? "object" : "rest"] | undefined; } : never;
        rest: never;
        never: never;
    }[Type extends string | number | boolean | import("../helpers/primitive").Primitive[] | null | undefined ? "never" : any extends Type ? "never" : Type extends {
        [k: string]: any;
    }[] ? "array" : (Type extends {
        [k: string]: any;
    } ? Type extends any[] ? false : true : false) extends true ? "object" : "rest"]>(_params: P) => ZodType<maskUtil.Pick<Type, P>, ZodTypeDef>;
    constructor(def: Def);
    abstract toJSON: () => object;
    abstract optional: () => any;
    abstract nullable: () => any;
}
